<template>
    <section class="carApply" style="margin-bottom:50px">
		<flash-message class="myCustomClass"></flash-message>

		<div v-if="firstStep">
		<hooper :itemsToShow="3"
    			:centerMode="false" 
    			:mouseDrag="false"
    			:touchDrag="false"
    			:wheelControl="false"
    			pagination="yes" 
    			ref="carousel"
    			
    			style="height: 100% !important;"
    			 @slide="updateCarousel">
    			

    		<slide >
		    	<div>

			        <div class="form-group float-label-control" id="makeDiv">

			          <label>Car Make</label>
			          <select v-model="vehicle.make_id" class="form-control"  required @change="getModels">
			            <option selected disabled>Select a Car Make</option>
			            <option v-for="make in cars" :value="make.iMakeId">{{ make.vMake }}</option>
			          </select>
			        </div>
			        <div class="form-group float-label-control">
			          <label>Car Model</label>
			          <select v-model="vehicle.model_id" class="form-control"  @change="getTypes" required placeholder="Select a Model">
						  <option selected disabled>Select a Car Model</option>
			             <option v-for="model in models" :value="model.iModelId">{{ model.vTitle }}</option>
			          </select>
			        </div>
			        <div class="form-group float-label-control">
			          <label>Car Type</label>
			          <select v-model="vehicle.type_id" class="form-control" @change="getColors" required placeholder="Select a type">
						  <option selected disabled>Select a Car Type</option>
			            <option v-for="type in types" :value="type.iCarTypeId">{{ type.vTitle_EN }}</option>
			          </select>
			        </div>
			        <div class="form-group float-label-control">
			          <label>Car Color</label>
			          <select v-model="vehicle.color_id"  class="form-control" @change="getYears"  required>
						  <option selected disabled>Select a Car Color</option>
			            <option v-for="color in colors" :value="color.iColourId">{{ color.vColour_EN }}</option>
			          </select>
			        </div>
			        <div class="form-group float-label-control">
			          <label>Car Year</label>
			          <select v-model="vehicle.year" class="form-control"  @change="checkInputs" required>
						  <option selected disabled>Select a Car Year</option>
						  <option v-for="year in years" :value="year">{{ year }}</option>
			          </select>
			        </div>

			        <div class="form-group float-label-control" >
			            <label> License Plate </label>
			            <input @change="checkInputs" v-model="vehicle.vehicle_tag" type="text"  name="vehicle_tag" class="form-control" required>
			        </div>
			        <!-- 
			        <button class="btn btn-primary"  :disabled="firstStep" @click.prevent="slideNext">		Continue
			        </button> -->

			        <button :disabled="allowContiue" class="btn btn-primary" @click.prevent="slideNext">	Continue </button>
		    	</div> 
		    	
	    	</slide>
	    	<slide>
	    		<flash-message class="myCustomClass"></flash-message>

		    	<div class="col-md-12 col-sm-12 form-group float-label-control">
               		<div class="alert alert-info"> 
               			<h3><strong>Upload a Picture of your Car Registration</strong></h3>
              			<p>Please make sure your name and expiration date are legible</p>
              		</div>
					<div v-show="registration">
			    		<image-uploader style="max-width:250px;"
					        :preview="true"
					        :className="['fileinput', { 'fileinput--loaded': hasRegistration }]"
					        capture="environment"
					        :debug="2"
					        :quality="0.7"
    						:autoRotate=true
					        outputFormat="verbose"
					        @input="setRegistration"
							:scaleRatio="1"
							
					     ></image-uploader>
					</div>
		    		<button class="btn btn-warning" @click.prevent="slidePrev()">Back</button>
					<button class="btn btn-primary" @click="slideNext(); registration = false;">
						Continue</button>
		    	</div>
		    </slide>

		    <slide>
				<flash-message class="myCustomClass"></flash-message>
    	
				<div class="alert alert-info">
					<h3><strong>Upload Insurance Picture</strong></h3>
					<p>Please make sure your name and expiration date are legible</p>
				</div>
				<div v-show="insurance">
				<image-uploader style="max-width: 250px !important;"
						:preview="true"
						:className="['fileinput', { 'fileinput--loaded': hasInsurance }]"
						capture="environment"
						:debug="0"
						:quality="0.7"
						:autoRotate=true
						outputFormat="verbose"
						@input="setInsurance"
						
				></image-uploader>
				</div>
				<button class="btn btn-warning" @click.prevent="slidePrev(); registration = true">Back</button>
				<button class="btn btn-primary" @click="slideNext(); insurance = false">Continue</button>

		    </slide>
			<slide>
				<flash-message class="myCustomClass"></flash-message>

				<div class="alert alert-info">
					<h3><strong>Upload Driver License Picture</strong></h3>
					<p>Please make sure your name and expiration date are legible</p>
				</div>
				<div v-show="license">
				<image-uploader
						:preview="true"
						:className="['fileinput', { 'fileinput--loaded': hasLicense }]"
						capture="environment"
						:debug="0"
						:quality="0.7"
						:autoRotate=true
						outputFormat="verbose"
						@input="setLicense"
				></image-uploader>
				</div> 
				<button class="btn btn-warning" @click.prevent="slidePrev(); insurance = true ">Back</button>
				<button class="btn btn-primary" @click="slideNext(); license = false">Continue</button>

			</slide>
			<slide>
				<flash-message class="myCustomClass"></flash-message>

				<div class="alert alert-info">
					<h3><strong>Upload Car Picture</strong></h3>
					<p>Please make sure your name and expiration date are legible</p>
				</div>
				<div v-show="auto">
					<span class="button" >
                            <input type="file" @change="onFileChanged" accept="image/*">
                            Upload image
					</span>

					<cropper
							v-if="notCropped"
							classname="cropper"
							:src="vehicle.car"
							:stencilProps="{
                                  aspectRatio: 1/1
                                }"
							ref="cropper"
					></cropper>
					<img v-if="crop" v-bind:src="vehicle.car" style="max-width:400px"/>
					<button v-show="showCropper" @click="cropped()" class="btn btn-default">
						Crop
					</button>
				</div>
				<button class="btn btn-warning" @click.prevent="slidePrev(); license = true">Back</button>
				<button class="btn btn-primary" @click="uploadImages">Continue</button>

			</slide>
			<hooper-progress slot="hooper-addons"></hooper-progress>

    	</hooper>
    	</div> 

    	<div v-if="secondStep">
    		<h3> Your Application has been submitted </h3> 
    		<p> Please allow us 24 hours to review your application to give a response </p> 
    		<a href="/dashboarduser/becomeDriver" class="btn btn-primary"> 
    			Return to Car Information 
    		</a> 
    	</div> 
    </section> 

</template> 

<script>
	import {
	  Hooper,
	  Slide,
	  Progress as HooperProgress,
	  Pagination as HooperPagination,
	  Navigation as HooperNavigation
	} from 'hooper';

	import { Cropper, ResizeEvent  } from 'vue-advanced-cropper'
	import 'hooper/dist/hooper.css';

	export default {
        components:{Hooper, Slide,HooperProgress,HooperPagination,HooperNavigation, Cropper, ResizeEvent},
        name: "newdriver",
        props:["vehicles"],
        data(){
        	return{
        		allowContiue:true,
        		firstStep:true,
        		secondStep:false,
        		insurance:true,
        		registration:true,
        		auto:true,
        		license:true,
        		carouselData: 0,
        		cars: JSON.parse(this.vehicles),
        		models:'',
        		types:'',
        		colors:'',
        		years:[],
				hasRegistration:false,
				hasInsurance:false,
				hasLicense:false,
				notCropped:true,
				crop:false,
				showCropper:false,
				vehicle:{
        			make_id:null,
        			model_id:null,
        			type_id:null,
        			color_id:null,
        			year:null,
					vehicle_tag:null,
					license:'',
					registration:'',
					car:'',
					insurance:'',
        		},
        	}
        },
        mounted(){
        	this.vehicle.make = this.cars[0].iMakeId;
        	this.getModels();
        	this.getYears();
        },
        watch: {
		    carouselData () {
		      this.$refs.carousel.slideTo(this.carouselData);
		    }

		},
        methods:{
			onFileChanged(event) {
				// Reference to the DOM input element
				var input = event.target;

				// Ensure that you have a file before attempting to read it
				if (input.files && input.files[0]) {
					// create a new FileReader to read this image and convert to base64 format
					var reader = new FileReader();
					// Define a callback function to run, when FileReader finishes its job
					reader.onload = (e) => {
						// Note: arrow function used here, so that "this.imageData" refers to the imageData of Vue component
						// Read image as base64 and set to imageData
						this.vehicle.car = e.target.result;
						this.showCropper = true;
					}
					// Start the reader job - read file as a data url (base64 format)
					reader.readAsDataURL(input.files[0]);
				}
			},
			cropped(){
				const {coordinates, canvas} = this.$refs.cropper.getResult();
				this.coordinates = coordinates;
				// You able to do different manipulations at a canvas
				// but there we just get a cropped image
				this.$refs.cropper.setCoordinates({
					width: coordinates.width,
					height: coordinates.height,
					left: coordinates.left,
					top: coordinates.top
				});
				this.image = canvas.toDataURL();
				this.crop = true;
				this.notCropped = false;
				this.showCropper=false;
			},
        	checkInputs:function(){
        		console.log("check");
				if(this.vehicle.make_id != null && this.vehicle.model_id != null && this.vehicle.type_id != null && this.vehicle.color_id != null && this.vehicle.year != null && this.vehicle.vehicle_tag != null){
        			this.allowContiue = false; 
        		}
        	},
			hideUploader:function(uploader){
				console.log(uploader);
				uploader = false;
				console.log(this.registration);

			},
			showUploader:function(uploader){
				uploader = true;
			},
        	setLicense: function(output) {
              this.hasLicense = true;
              this.vehicle.license = output;
            },
			setInsurance: function(output) {
				this.hasInsurance = true;
				this.vehicle.insurance = output;
			},
			setRegistration: function(output) {
				this.hasRegistration = true;
				this.vehicle.registration = output;
			},
			setCar:function(output){
        		this.hasCar = true;
        		this.vehicle.car = output;
			},
        	slidePrev() {
		      	this.$refs.carousel.slidePrev();
		      	$('html, body').animate({ scrollTop: 175 }, 'slow');
		    },
		    slideNext() {
		      this.$refs.carousel.slideNext();
		      $('html, body').animate({ scrollTop: 175 }, 'slow');
		    },
		    updateCarousel(payload) {
		      this.myCarouselData = payload.currentSlide;
		    },
		    getModels(){
		    	console.log(this.vehicle.make);
		    	 axios.post('/dashboarduser/fetchModel', {
  
                    'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content'),
                    'make':this.vehicle.make_id
   
                }).then(response => {
                    this.models = response.data;

                }).catch(e => {
                    this.errors.push(e)
                })
                this.checkInputs();
		    },
		    getTypes(){
		    	axios.post('/dashboarduser/fetchType', {
					'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content'),

                }).then(response => {
                    this.types = response.data;

                }).catch(e => {
                    this.errors.push(e)
                })
                this.checkInputs();
		    },
		    getColors(){
		    	axios.post('/dashboarduser/fetchColor', {
                        'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content'),

                }).then(response => {
                    this.colors = response.data;

                }).catch(e => {
                    this.errors.push(e)
                })
                this.checkInputs();
		    },
		    getYears(){
		    	var temp = [];
		    	for(var i=0; i < 60; i++){
		    		temp[i] = (2019 - i);
		    	}
		    	this.years = temp;
		    },
			uploadImages(){
        		try{
					this.uploadDriver();
					
					this.flash('Your Application will reviewed as soon as possible', 'Success', {timeout: 3000});

				}catch(err){
					this.flash(err, 'error',{timeout: 3000});
				}
			},
			uploadDriver(){
				jQuery('#loading').show();

				axios.post('/dashboarduser/saveDriver', {
					body: {
						'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content'),
						'vehicle' : this.vehicle,
					}
				}).then(response => {

					this.uploadDriverLicense();
					
				}).catch(e => {
					if(e.response){
						this.flash(e.response.data.message, 'error',{timeout: 3000});

					}else{
						this.flash('Error 500, there was a problem with the server',
								'error',{timeout: 3000});
					}
					$('html, body').animate({ scrollTop: 200 }, 'slow');
					console.log(e);
				})
			},
			uploadDriverLicense(){
				$('#loading').show();
				axios.post('/dashboarduser/saveLicense', {
					body: {
						'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content'),
						'image' : this.vehicle.license.dataUrl,
					}
				}).then(response => {
					this.uploadRegistration();
					

				}).catch(e => {
					if(e.response){
						this.flash(e.response.data.message, 'error',{timeout: 3000});
					}else{
						this.flash('Error 500, there was a problem with the server',
								'error',{timeout: 3000});
					}
					$('html, body').animate({ scrollTop: 200 }, 'slow');
					console.log(e);
					$('#loading').hide();
				})
			},
		    uploadRegistration(){
		    	$('#loading').show();
                axios.post('/dashboarduser/saveRegistration', {
                    body: {
                        'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content'),
                        'image' : this.vehicle.registration.dataUrl,
                    }
                }).then(response => {
                    this.uploadInsurance();
					

                }).catch(e => {
                	if(e.response){
						this.flash(e.response.data.message, 'error',{timeout: 3000});

					}else{
                    	this.flash('Error 500, there was a problem with the server', 
                    		'error',{timeout: 3000});
                	}
                	$('html, body').animate({ scrollTop: 200 }, 'slow');
                    console.log(e);
                    $('#loading').hide();
                })
            },
			uploadInsurance() {
				$('#loading').show();
				axios.post('/dashboarduser/saveInsurance', {
					body: {
						'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content'),
						'image': this.vehicle.insurance.dataUrl,
					}
				}).then(response => {
					this.uploadCarImage();

				}).catch(e => {
					if (e.response) {
						this.flash(e.response.data.message, 'error',{timeout: 3000});

					} else {
						this.flash('Error 500, there was a problem with the server',
								'error', {timeout: 3000});
					}
					$('html, body').animate({scrollTop: 200}, 'slow');
					console.log(e);
					$('#loading').hide();
				})
			},
			uploadCarImage(){
				$('#loading').show();
				axios.post('/dashboarduser/saveCarImage', {
					body: {
						'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content'),
						'image': this.vehicle.car,
					}
				}).then(response => {
					jQuery('#loading').hide();
					this.firstStep = false;
					this.secondStep = true; 
					setTimeout(function(){ 
						this.firstStep = false;
						this.secondStep = true; 
					}, 4000);
					

				}).catch(e => {
					if (e.response) {
						this.flash(e.response.data.message, 'error', {timeout: 3000});

					} else {
						this.flash('Error 500, there was a problem with the server',
								'error', {timeout: 3000});
					}
					$('html, body').animate({scrollTop: 200}, 'slow');
					console.log(e);
					$('#loading').hide();
				})
			}
        }
    }
</script> 
<style scoped>
	li.hooper-slide.is-active.is-current {
    	width: 100% !important;
	}
	.hooper{
		min-height: 1000px;
	}

	@media only screen and (max-width: 550px){
		.hooper{
			min-height: 1000px;
		}
	}
</style>